//
// Date Last Modified: June 12th, 2007
//
// Modified By: Kelsenellenelvian
//


// Set some specific environment variables for WPI
function defaultWPI()
{
	position="core.js";
	whatfunc="defaultWPI()";

	// %wpipath%
	wpipath = unescape(document.location);
	wpipath = wpipath.substring(0,wpipath.lastIndexOf("/"));
	wpipath = wpipath.replace("file:///","").replace(/\//g,"\\");


	// Universal Silent Switch Finder
	USSFcmd=wpipath+"\\Tools\\USSF.exe";


	// %root%
	root=fso.GetParentFolderName(wpipath);


	// %dospath%
	if (FileExists(sysdir + "$winnt$.inf"))    
	{                                   		
		var winntinf=fso.OpenTextFile(sysdir + "$winnt$.inf", 1);        		// It's recorded in the 'dospath' directive of the [data] section of \system32\$winnt$.inf.		
		var matches = winntinf.ReadAll().match(/\ndospath=(.*)/i);		
		winntinf.Close();		
		if (matches)                                                        		
		{			
			dospath=matches[1];                                            			
			if (dospath.substring(dospath.length - 2, dospath.length - 1)=="\\")//dospath may have a trailing slash ... or not (depending on the location)				
				dospath = dospath.substring(0, dospath.length - 2);        		// So let's remove it if it's there		
		}    
	}       
//	FYI: x64 stores this file in system32 but since the app that runs your script (mshta.exe) is only 32-bit it references SysWOW64 instead of system32


	// %HDD%
	var a, i, li = new Array();

	hdd="";
	if (i=wpipath.indexOf(":") != -1 && !ResumeInstall)
	{
		var temp;

		temp=wpipath.substr(0,2);
		a=DriveType(temp);

		if (a !="UNKNOWN" && a !="CDROM")										// Not UNKNOWN and not CDROM
			hdd=temp;
		else
			hdd="";
	}


	// %CDROM%
	li = GetDriveLetters(4);
	for (i=0; i<li.length; i++)
	{
		if (FileExists(li[i]+'\\WPI.HTA') || FileExists(li[i]+'\\WIN51') || FileExists(li[i]+'\\I386\\DRIVER.CAB') || FileExists(li[i]+'\\Sources\\install.wim'))
			cddrv = li[i];
	}

	if (cddrv=="")
	{
		a = fso.GetAbsolutePathName(".");
		while (a.length>=3)
		{
	 		if (FileExists(a+'\\WPI.HTA'))
	 		{
	 			cddrv=a;
				break;
	 		}
	 		if (a.length==3) 
				break;
	 		a = a + "\\..";
			a = fso.GetAbsolutePathName(a);
	 	}
	}

	if (cddrv=="")
	{
		cddrv = WshShell.RegRead("HKLM\\Software\\Microsoft\\Windows\\CurrentVersion\\Setup\\SourcePath") + "\\";
		cddrv = cddrv.substr(0,3);
	}


	// %OSLANG%
	var sLang = '', Enum, DtoH;

	CreateLocalArray();

	// OSLanguage = 1033, 1036, ....
	var OSProps = GetObject("winmgmts:").InstancesOf("Win32_OperatingSystem");

	// Language ID in Dec
	sLang = new Enumerator(OSProps).item();
	Enum = sLang.OSLanguage;
	DtoH = DecToHex(Enum);
	while (DtoH.length<4)  
		DtoH = "0" + DtoH+"";

	for (var x=0; x<arrOSLang.length; x++)
	{
		if (arrOSLang[x].LCID == DtoH)
		{
			oslang=arrOSLang[x].TLA;
			break;
		}
	}
}


function CreateLocalArray()
{
	var i = 0;

	arrOSLang[i++] = new AddLocal("Afrikaans - South Africa","AFK","0436");
	arrOSLang[i++] = new AddLocal("Albanian - Albania","SQI","041c");
	arrOSLang[i++] = new AddLocal("Arabic - Algeria","ARG","1401");
	arrOSLang[i++] = new AddLocal("Arabic - Bahrain","ARH","3c01");
	arrOSLang[i++] = new AddLocal("Arabic - Egypt","ARE","0c01");
	arrOSLang[i++] = new AddLocal("Arabic - Iraq","ARI","0801");
	arrOSLang[i++] = new AddLocal("Arabic - Jordan","ARJ","2c01");
	arrOSLang[i++] = new AddLocal("Arabic - Kuwait","ARK","3401");
	arrOSLang[i++] = new AddLocal("Arabic - Lebanon","ARB","3001");
	arrOSLang[i++] = new AddLocal("Arabic - Libya","ARL","1001");
	arrOSLang[i++] = new AddLocal("Arabic - Morocco","ARM","1801");
	arrOSLang[i++] = new AddLocal("Arabic - Oman","ARO","2001");
	arrOSLang[i++] = new AddLocal("Arabic - Qatar","ARQ","4001");
	arrOSLang[i++] = new AddLocal("Arabic - Saudi Arabia","ARA","0401");
	arrOSLang[i++] = new AddLocal("Arabic - Syria","ARS","2801");
	arrOSLang[i++] = new AddLocal("Arabic - Tunisia","ART","1c01");
	arrOSLang[i++] = new AddLocal("Arabic - U.A.E.","ARU","3801");
	arrOSLang[i++] = new AddLocal("Arabic - Yemen","ARY","2401");
	arrOSLang[i++] = new AddLocal("Armenian - Armenia","HYE","042b");
	arrOSLang[i++] = new AddLocal("Azeri - Azerbaijan (Cyrillic)","AZE","082c");
	arrOSLang[i++] = new AddLocal("Azeri - Azerbaijan (Latin)","AZE","042c");
	arrOSLang[i++] = new AddLocal("Basque - Spain","EUQ","042d");
	arrOSLang[i++] = new AddLocal("Belarusian - Belarus","BEL","0423");
	arrOSLang[i++] = new AddLocal("Bulgarian - Bulgaria","BGR","0402");
	arrOSLang[i++] = new AddLocal("Catalan - Spain","CAT","0403");
	arrOSLang[i++] = new AddLocal("Chinese - Hong Kong SAR","ZHH","0c04");
	arrOSLang[i++] = new AddLocal("Chinese - Macau SAR","ZHM","1404");
	arrOSLang[i++] = new AddLocal("Chinese - PRC","CHS","0804");
	arrOSLang[i++] = new AddLocal("Chinese - Singapore","ZHI","1004");
	arrOSLang[i++] = new AddLocal("Chinese - Taiwan","CHT","0404");
	arrOSLang[i++] = new AddLocal("Croatian - Croatia","HRV","041a");
	arrOSLang[i++] = new AddLocal("Czech - Czech Republic","CSY","0405");
	arrOSLang[i++] = new AddLocal("Danish - Denmark","DAN","0406");
	arrOSLang[i++] = new AddLocal("Divehi - Maldives","DIV","0465");
	arrOSLang[i++] = new AddLocal("Dutch - Belgium","NLB","0813");
	arrOSLang[i++] = new AddLocal("Dutch - Netherlands","NLD","0413");
	arrOSLang[i++] = new AddLocal("English - Australia","ENA","0c09");
	arrOSLang[i++] = new AddLocal("English - Belize","ENL","2809");
	arrOSLang[i++] = new AddLocal("English - Canada","ENC","1009");
	arrOSLang[i++] = new AddLocal("English - Caribbean","ENB","2409");
	arrOSLang[i++] = new AddLocal("English - Ireland","ENI","1809");
	arrOSLang[i++] = new AddLocal("English - Jamaica","ENJ","2009");
	arrOSLang[i++] = new AddLocal("English - New Zealand","ENZ","1409");
	arrOSLang[i++] = new AddLocal("English - Philippines","ENP","3409");
	arrOSLang[i++] = new AddLocal("English - South Africa","ENS","1c09");
	arrOSLang[i++] = new AddLocal("English - Trinidad","ENT","2c09");
	arrOSLang[i++] = new AddLocal("English - United Kingdom","ENG","0809");
	arrOSLang[i++] = new AddLocal("English - United States","ENU","0409");
	arrOSLang[i++] = new AddLocal("English - Zimbabwe","ENW","3009");
	arrOSLang[i++] = new AddLocal("Estonian - Estonia","ETI","0425");
	arrOSLang[i++] = new AddLocal("Faeroese - Faeroe Islands","FOS","0438");
	arrOSLang[i++] = new AddLocal("Farsi - Iran","FAR","0429");
	arrOSLang[i++] = new AddLocal("Finnish - Finland","FIN","040b");
	arrOSLang[i++] = new AddLocal("French - Belgium","FRB","080c");
	arrOSLang[i++] = new AddLocal("French - Canada","FRC","0c0c");
	arrOSLang[i++] = new AddLocal("French - France","FRA","040c");
	arrOSLang[i++] = new AddLocal("French - Luxembourg","FRL","140c");
	arrOSLang[i++] = new AddLocal("French - Monaco","FRM","180c");
	arrOSLang[i++] = new AddLocal("French - Switzerland","FRS","100c");
	arrOSLang[i++] = new AddLocal("FYRO Macedonian - FYRO Macedonia","MKI","042f");
	arrOSLang[i++] = new AddLocal("Galician - Spain","GLC","0456");
	arrOSLang[i++] = new AddLocal("Georgian - Georgia","KAT","0437");
	arrOSLang[i++] = new AddLocal("German - Austria","DEA","0c07");
	arrOSLang[i++] = new AddLocal("German - Germany","DEU","0407");
	arrOSLang[i++] = new AddLocal("German - Liechtenstein","DEC","1407");
	arrOSLang[i++] = new AddLocal("German - Luxembourg","DEL","1007");
	arrOSLang[i++] = new AddLocal("German - Switzerland","DES","0807");
	arrOSLang[i++] = new AddLocal("Greek - Greece","ELL","0408");
	arrOSLang[i++] = new AddLocal("Gujarati - India (Gujarati Script)","GUJ","0447");
	arrOSLang[i++] = new AddLocal("Hebrew - Israel","HEB","040d");
	arrOSLang[i++] = new AddLocal("Hindi - India","HIN","0439");
	arrOSLang[i++] = new AddLocal("Hungarian - Hungary","HUN","040e");
	arrOSLang[i++] = new AddLocal("Icelandic - Iceland","ISL","040f");
	arrOSLang[i++] = new AddLocal("Indonesian - Indonesia","IND","0421");
	arrOSLang[i++] = new AddLocal("Italian - Italy","ITA","0410");
	arrOSLang[i++] = new AddLocal("Italian - Switzerland","ITS","0810");
	arrOSLang[i++] = new AddLocal("Japanese - Japan","JPN","0411");
	arrOSLang[i++] = new AddLocal("Kannada - India (Kannada Script)","KAN","044b");
	arrOSLang[i++] = new AddLocal("Kazakh - Kazakstan","KKZ","043f");
	arrOSLang[i++] = new AddLocal("Konkani - India","KNK","0457");
	arrOSLang[i++] = new AddLocal("Korean(Extended Wansung) - Korea","KOR","0412");
	arrOSLang[i++] = new AddLocal("Kyrgyz - Kyrgyzstan","KYR","0440");
	arrOSLang[i++] = new AddLocal("Latvian - Latvia","LVI","0426");
	arrOSLang[i++] = new AddLocal("Lithuanian - Lithuania","LTH","0427");
	arrOSLang[i++] = new AddLocal("Malay - Brunei Darussalam","MSB","083e");
	arrOSLang[i++] = new AddLocal("Malay - Malaysia","MSL","043e");
	arrOSLang[i++] = new AddLocal("Marathi - India","MAR","044e");
	arrOSLang[i++] = new AddLocal("Mongolian (Cyrillic) - Mongolia","MON","0450");
	arrOSLang[i++] = new AddLocal("Norwegian - Norway (Bokml)","NOR","0414");
	arrOSLang[i++] = new AddLocal("Norwegian - Norway (Nynorsk)","NON","0814");
	arrOSLang[i++] = new AddLocal("Polish - Poland","PLK","0415");
	arrOSLang[i++] = new AddLocal("Portuguese - Brazil","PTB","0416");
	arrOSLang[i++] = new AddLocal("Portuguese - Portugal","PTG","0816");
	arrOSLang[i++] = new AddLocal("Punjabi - India (Gurmukhi Script)","PAN","0446");
	arrOSLang[i++] = new AddLocal("Romanian - Romania","ROM","0418");
	arrOSLang[i++] = new AddLocal("Russian - Russia","RUS","0419");
	arrOSLang[i++] = new AddLocal("Sanskrit - India","SAN","044f");
	arrOSLang[i++] = new AddLocal("Serbian - Serbia (Cyrillic)","SRB","0c1a");
	arrOSLang[i++] = new AddLocal("Serbian - Serbia (Latin)","SRL","081a");
	arrOSLang[i++] = new AddLocal("Slovak - Slovakia","SKY","041b");
	arrOSLang[i++] = new AddLocal("Slovenian - Slovenia","SLV","0424");
	arrOSLang[i++] = new AddLocal("Spanish - Argentina","ESS","2c0a");
	arrOSLang[i++] = new AddLocal("Spanish - Bolivia","ESB","400a");
	arrOSLang[i++] = new AddLocal("Spanish - Chile","ESL","340a");
	arrOSLang[i++] = new AddLocal("Spanish - Colombia","ESO","240a");
	arrOSLang[i++] = new AddLocal("Spanish - Costa Rica","ESC","140a");
	arrOSLang[i++] = new AddLocal("Spanish - Dominican Republic","ESD","1c0a");
	arrOSLang[i++] = new AddLocal("Spanish - Ecuador","ESF","300a");
	arrOSLang[i++] = new AddLocal("Spanish - El Salvador","ESE","440a");
	arrOSLang[i++] = new AddLocal("Spanish - Guatemala","ESG","100a");
	arrOSLang[i++] = new AddLocal("Spanish - Honduras","ESH","480a");
	arrOSLang[i++] = new AddLocal("Spanish - Mexico","ESM","080a");
	arrOSLang[i++] = new AddLocal("Spanish - Nicaragua","ESI","4c0a");
	arrOSLang[i++] = new AddLocal("Spanish - Panama","ESA","180a");
	arrOSLang[i++] = new AddLocal("Spanish - Paraguay","ESZ","3c0a");
	arrOSLang[i++] = new AddLocal("Spanish - Peru","ESR","280a");
	arrOSLang[i++] = new AddLocal("Spanish - Puerto Rico","ESU","500a");
	arrOSLang[i++] = new AddLocal("Spanish - Spain (International Sort)","ESN","0c0a");
	arrOSLang[i++] = new AddLocal("Spanish - Spain (Traditional Sort)","ESP","040a");
	arrOSLang[i++] = new AddLocal("Spanish - Uruguay","ESY","380a");
	arrOSLang[i++] = new AddLocal("Spanish - Venezuela","ESV","200a");
	arrOSLang[i++] = new AddLocal("Swahili - Kenya","SWK","0441");
	arrOSLang[i++] = new AddLocal("Swedish - Finland","SVF","081d");
	arrOSLang[i++] = new AddLocal("Swedish - Sweden","SVE","041d");
	arrOSLang[i++] = new AddLocal("Syriac - Syria","SYR","045a");
	arrOSLang[i++] = new AddLocal("Tamil - India","TAM","0449");
	arrOSLang[i++] = new AddLocal("Tatar - Tatarstan","TTT","0444");
	arrOSLang[i++] = new AddLocal("Telugu - India (Telugu Script)","TEL","044a");
	arrOSLang[i++] = new AddLocal("Thai - Thailand","THA","041e");
	arrOSLang[i++] = new AddLocal("Turkish - Turkey","TRK","041f");
	arrOSLang[i++] = new AddLocal("Ukrainian - Ukraine","UKR","0422");
	arrOSLang[i++] = new AddLocal("Urdu - Pakistan","URD","0420");
	arrOSLang[i++] = new AddLocal("Uzbek - Uzbekistan (Cyrillic)","UZB","0843");
	arrOSLang[i++] = new AddLocal("Uzbek - Uzbekistan (Latin)","UZB","0443");
	arrOSLang[i++] = new AddLocal("Vietnamese - Viet Nam","VIT","042a");
}


function AddLocal(sLocal,sTLA,sLCID) 
{
	this.Local = sLocal;
	this.TLA = sTLA;
	this.LCID = sLCID;
}


function DecToHex(d) 
{
	var hD="0123456789ABCDEF";
	var h = hD.substr(d&15,1);

	while(d>15) 
	{
		d>>=4;
		h=hD.substr(d&15,1)+h;
	}

	return h;
}


function SetScriptWaitTimeout(timeout) // max is 4294967295
{
	position="core.js";
	whatfunc="SetScriptWaitTimeout()";

	var val=0;
	var KeyBase="HKCU\\Software\\Microsoft\\Internet Explorer\\Styles\\MaxScriptStatements";

	try
	{
		if (timeout<0) 
		{
			try
			{
				WshShell.RegDelete(KeyBase);

				return;
			}
			catch(ex)
			{ ; }
		}

		try
		{
			val=WshShell.RegRead(KeyBase);
		} 
		catch (exc) 
		{
			if (timeout==0 || !timeout) 
				timeout=0x7fffffff;
			WshShell.RegWrite(KeyBase,timeout,"REG_DWORD");
		} 
	} 
	catch (ex2) 
	{ ; }
}


function ReplacePath(v)
{     
	position="core.js";    
	whatfunc="ReplacePath()";    
	
	var i, rs = new String(v);    

	rs = rs.replace(/%wpipath%/gi, wpipath);									// Replace WPI's special environment variables
	rs = rs.replace(/%root%/gi, root);											// WPI parent folder
	
	if (hdd=="")
		rs = rs.replace(/%cdrom%/gi, cddrv);									// started from cdrom 
	else
	rs = rs.replace(/%cdrom%/gi, hdd);                                      // not started from cdrom
	rs = rs.replace(/%sysdir%/gi, sysdir);                                      // same as before  
	rs = rs.replace(/%dospath%/gi, dospath);									// new variable
	rs = rs.replace(/%oslang%/gi, oslang);										// operating system language code
	rs = rs.replace(/%reboot%/gi, 'shutdown.exe -r -f -t ');					// force a reboot after X seconds
	rs = rs.replace(/%reboot%/gi, 'shutdown.exe -r -f -t 0');					// force a reboot now
	rs = rs.replace(/%sleep%/gi, wpipath+"\\Tools\\Sleep.exe");					// Pause for x seconds
	rs = rs.replace(/%extract%/gi, '"'+wpipath+"\\WPIScripts\\ExtractToPath.vbs"+'"');					// Archive Extraction

	// Replace other (standard) environment variables (either global or defined in the process calling WPI)    
	var envarname, envvars = rs.match(/%[^ %\f\n\r\t\v]+%/gi);                  // find ALL substrings enclosed in '%' and not containing '%' itself or a white space character    
	if (envvars)                                                                // if any match     
	{         
		for (i=0; i<envvars.length; i++)                                         // loop on the matches        
		{            
			envarname=envvars[i].substring(1, envvars[i].length - 1);			// strip the match from its enclosing '%'            
			rs = rs.replace(envvars[i],WshEnv(envarname));						// replace it by the corresponding env var
		}    
	}    

	return rs;
}


function getText(par)
{
	position="core.js";
	whatfunc="getText()";

	if (par[Language]) 
		return par[Language];

	return par['en'];
}

function GetFileVersion(filespec)
{
position="core.js";
whatfunc="GetFileVersion()";

return fso.getfileversion(filespec);
}

function FileExists(filespec)
{
	position="core.js";
	whatfunc="FileExists()";

	return fso.FileExists(filespec);
}


function GetDriveLetters(type)
{
	position="core.js";
	whatfunc="GetDriveLetters()";

// types: 0=Unknown, 1=Removable, 2=Fixed Disk, 3=Network Share, 4=CDROM, 5=RAM Disk
	var da, en, ite;

	da = new Array();
	en = new Enumerator(fso.Drives);
	for (; !en.atEnd(); en.moveNext())
	{
		ite = en.item();
		if (ite.DriveType == type)
	  		da[da.length++]=(ite.DriveLetter + ":");
	}

	return da;
}


function DriveExists(letter)
{
	position="core.js";
	whatfunc="DriveExists()";

	return fso.DriveExists(letter);
}


function DriveType(letter)
{
	position="core.js";
	whatfunc="DriveType()";

// types: 0=Unknown, 1=Removable, 2=Fixed Disk, 3=Network Share, 4=CDROM, 5=RAM Disk
	var type, li = new Array();

	for (type=1; type<6; type++)
	{
		li=[];
		li=GetDriveLetters(type);
		for (var i=0; i<li.length; i++)
		{
			if (li[i]==letter)
				return driveTypes[type];
		}
	}

	return driveTypes[0];
}


function Pause(secs,milli)
{
	position="core.js";
	whatfunc="Pause()";
	var SleepShell = new ActiveXObject("WScript.Shell");
	var duration, sleepCmd;

	duration="-m " + ((secs*1000)+milli);
	sleepCmd=wpipath+"\\Tools\\Sleep.exe";
	SleepShell.Run('"'+sleepCmd+'" '+duration,0,true);

// If you have any issues with security prompts on Server 2003, use this line
//	SleepShell.Run('cmd /c "'+sleepCmd+'" '+duration,0,true);
}


function ExitWPI()
{
	SetScriptWaitTimeout(-1);

	if (getOSver()=="XP")
	{
		try
		{
			WshShell.RegDelete("HKEY_CURRENT_USER\\Software\\Microsoft\\Windows\\CurrentVersion\\Policies\\Associations\\LowRiskFileTypes");
			WshShell.RegDelete("HKEY_CURRENT_USER\\Software\\Microsoft\\Windows\\CurrentVersion\\Policies\\Associations\\");
		}
		catch(ex)
		{ ; }
	}

	self.close();
}
