//
// Date Last Modified: Thursday, November 09, 2006
//
// Modified By: Mark Ritter (mritter)
//


function CheckThemeVersion()
{
	position="main.js";
	whatfunc="CheckThemeVersion()";

	var line=new String();	
	var num=1, success=true;
	var txt;

	if (!FileExists(wpipath + "\\Themes\\" + Theme + "\\wpi.htm"))
	{
		alert("'"+Theme+"' theme does not exist.\n\nSwitching to 'Glossy', the default theme.");
		Theme='Glossy';

		return false;
	}

	try 
	{
		tf = fso.OpenTextFile(wpipath + "\\Themes\\" + Theme + "\\wpi.htm", 1);
		while (!tf.AtEndOfStream && num<4)
		{
			line = tf.ReadLine();
			if (num==3 && line != '<meta content="WPI Theme 5.5+">')
			{
				txt=("'" + Theme + "' is not a v5.5+ compatible theme.");
				if (AtStartUp)
				{
					txt += "\n\nSwitching to 'Glossy', the default theme.";
					Theme='Glossy';
				}
				alert(txt);
				success=false;
			}
			num++;
		}
	}
	catch(ex) 
	{ ;	}
	finally 
	{	
		tf.Close(); 
	}

	return success;
}


function LoadThemedContent()
{
	position="main.js";
	whatfunc="LoadThemedContent()";

	if (RandomTheme)
	{
		GetThemes();
		Theme=ThemesArray[Math.floor(Math.random()*(ThemesArray.length))];
	}

	if (!CheckThemeVersion())
	{
		if (AtStartUp)
		{
			if (!CheckThemeVersion())
			{
				if (AtStartUp)
				{
					alert("'Glossy' theme could not be loaded.  Re-install the theme.");

					return false;
				}
			}			
		}	
		else
			return false;
	}

	try 
	{
		tf = fso.OpenTextFile(wpipath + "\\Themes\\" + Theme + "\\wpi.htm", 1);
		while (!tf.AtEndOfStream)
		{
			line = tf.ReadAll();
			document.write(line);
		}
	}
	catch(ex) 
	{ 
		alert("LoadThemeContent() error:"+ex.message); 
	}
	finally 
	{	
		tf.Close(); 
	}

	SetupTips();

	return true;
}


function HideLayers()
{
	position="main.js";
	whatfunc="HideLayers()";

	try
 	{
 		for (var i=0; i<document.all.layergroup.childNodes.length; i++)
 		{
 			var node=document.all.layergroup.childNodes[i];

			if (!node.id || node.id.substr(0,5) != "layer") 
				continue;
 			node.style.display='none';
		}
	} 
	catch(de) 
	{ ; }
}	


function ShowMain()
{
    position="main.js";
    whatfunc="ShowMain()";

	ManualSection="Main";

	HideLayers();
    document.getElementById("InstallButton").style.visibility = 'visible';
    document.getElementById("layerboxes").style.display = 'block';
}


function ToggleSource()
{
    position="main.js";
    whatfunc="ToggleSource()";

	if (document.getElementById("layersource").style.display == 'none')
		ShowSource(); 
	else
		HideSource();	
}


function ShowSource()
{
    position="main.js";
    whatfunc="ShowSource()";

    var SourceLines = new Array(); 
    var TextLines = '<table border="0"><tr><td style="font-family:arial; font-size:x-small;">';
    var TextSource = '';
    var LongestLine = 0;

    document.getElementById("layersource").innerHTML = "";
    document.getElementById("InstallButton").style.visibility = 'hidden'; 

	SourceLines = (document.firstChild.innerHTML ).replace(/<\/textarea/gi, '<textara').split('\n');
    for (aux in SourceLines)
    {
        TextLines += (aux < 9 ? '0' : '') + (aux < 99 ? '0' : '') + (parseInt(aux) + 1) + '\n';
        TextSource += SourceLines[aux] + '\n'; 
        LongestLine = Math.max(LongestLine, SourceLines[aux].length);
    }
    HideLayers();
    document.getElementById("layersource").innerHTML = TextLines + '</td><td style="font-family:verdana;font-size:x-small;"><textarea cols="' + LongestLine + '" rows="' + SourceLines.length + '" readonly>' + TextSource + '</textarea></td></tr></table>';
    document.getElementById("layersource").style.display = 'block';
}


function HideSource()
{
    position="main.js";
    whatfunc="HideSource()";

	ShowMain();
}


function ToggleManual()
{
	position="main.js";
	whatfunc="ToggleManual()";

	if (document.getElementById("layermanual").style.display == 'none')
		ShowManual(); 
	else
		HideManual();	
}


function ShowManual()
{
	position="main.js";
	whatfunc="ShowManual()";

	var txt=new String(); txt = "";
 
	strFile = wpipath + "\\Manual\\manual.htm";
	if (!FileExists(strFile))
	{
		alert(getText(errCouldNotOpenFile)+" '"+strFile+"'.");
		HideManual();

		return;
	}
	try 
	{
		tf = fso.OpenTextFile(strFile, 1);
		while (!tf.AtEndOfStream)
			txt = tf.ReadAll();
	}
	catch (ex) 
	{ ; }
	finally 
	{	
		tf.Close(); 
	}
	
	HideLayers();
	document.getElementById("layermanual").innerHTML = txt;
	document.getElementById("txtWPIManual").innerHTML = getText(txtWPIManual);
	document.getElementById("txtExpandAll").innerHTML = getText(txtExpandAll);
	document.getElementById("txtCollapseAll").innerHTML = getText(txtCollapseAll);

	document.getElementById("InstallButton").style.visibility = 'hidden';
	document.getElementById("layermanual").style.display = 'block';

	ManualTree=new dhtmlXTreeObject(document.getElementById('manual_toc'),"100%","100%",0);
	ManualTree.setImagePath("./Manual/imgs/");
	ManualTree.setOnClickHandler(onManualClick);
	ManualTree.enableTreeLines(true);
	ManualTree.loadXML("./Manual/toc.xml")

	if (ManualSection=="Options")
	{
		var tab=optionsTabs.getActiveTab();
		if (tab=="Tab1")
			ManualTree.selectItem("tab_interface",1,0);
		else if (tab=="Tab2")
			ManualTree.selectItem("tab_installer",1,0);
		else if (tab=="Tab3")
			ManualTree.selectItem("tab_audioplayer",1,0);
		else if (tab=="Tab4")
			ManualTree.selectItem("tab_tools",1,0);
		else
			ManualTree.selectItem("tab_interface",1,0);
	}
	else if (ManualSection=="Config")
		ManualTree.selectItem("navigation",1,0);
	else
		ManualTree.selectItem("what_is_wpi",1,0);
}	


function onManualClick(id)
{
	position="main.js";
	whatfunc="onManualClick()";

	strFile = Manual_getFile(id) || "main.htm";

	if (strFile != "")
	{
		if (!ManualTree.getUserData(id,"type"))
		{
			var txt=new String(); txt = "";
 
			strFile = wpipath + "\\Manual\\"+strFile;
			if (!FileExists(strFile))
			{
				alert(getText(errCouldNotOpenFile)+" '"+strFile+"'.");
				HideManual();

				return;
			}
			try 
			{
				tf = fso.OpenTextFile(strFile, 1);
				while (!tf.AtEndOfStream)
					txt = tf.ReadAll();
			}
			catch (ex) 
			{ ; }
			finally 
			{	
				tf.Close(); 
			}

			document.getElementById("manual_content").innerHTML=txt;
			document.getElementById("manual_content").document.location="#"+id;
		}
	}
}


function Manual_getFile(id)
{
	position="main.js";
	whatfunc="Manual_getFile()";

	while(!ManualTree.getUserData(id,"file") && ManualTree.getLevel(id)>0)
		id=ManualTree.getParentId(id)

	return ManualTree.getUserData(id,"file");
}


function HideManual()
{
	position="main.js";
	whatfunc="HideManual()";

	ShowMain();
}


function ToggleAboutWPI()
{
	position="main.js";
	whatfunc="ToggleAboutWPI()";

	if (document.getElementById("layeraboutwpi").style.display == 'none')
		ShowAboutWPI(); 
	else
		HideAboutWPI();	
}


function ShowAboutWPI()
{
	position="main.js";
	whatfunc="ShowAboutWPI()";

	var txt=new String(); txt = "";
 
	strFile = wpipath + "\\Common\\aboutwpi.htm";
	if (!FileExists(strFile))
	{
		alert(getText(errCouldNotOpenFile)+" '"+strFile+"'.");
		HideAboutWPI();
	}
	try 
	{
		tf = fso.OpenTextFile(strFile, 1);
		while (!tf.AtEndOfStream)
			txt = tf.ReadAll();
	}
	catch (ex) 
	{ ; }
	finally 
	{	
		tf.Close(); 
	}
	
	HideLayers();
	document.getElementById("layeraboutwpi").innerHTML = txt;
	document.getElementById("InstallButton").style.visibility = 'hidden';
	document.getElementById("layeraboutwpi").style.display = 'block';
}	


function HideAboutWPI()
{
	position="main.js";
	whatfunc="HideAboutWPI()";

	ShowMain();
}


function ToggleGenUIDImage(id,state)
{
	position="main.js";
	whatfunc="ToggleGenUIDImage()";

	switch (state)
	{
		case 0:		
			document.getElementById(id).src = './Themes/'+Theme+'/GenUID_Out.jpg';
			break;

		case 1:
			document.getElementById(id).src = './Themes/'+Theme+'/GenUID_Over.jpg';
			break;

		case 2:	
			document.getElementById(id).src = './Themes/'+Theme+'/GenUID_Down.jpg';
			break;

		case 3:	
			document.getElementById(id).src = './Themes/'+Theme+'/GenUID_Disabled.jpg';
			break;
	}
}	


function ToggleFolderImage(id,state)
{
	position="main.js";
	whatfunc="ToggleFolderImage()";

	switch (state)
	{
		case 0:		
			document.getElementById(id).src = './Themes/'+Theme+'/Folder_Out.jpg';
			break;

		case 1:
			document.getElementById(id).src = './Themes/'+Theme+'/Folder_Over.jpg';
			break;

		case 2:	
			document.getElementById(id).src = './Themes/'+Theme+'/Folder_Down.jpg';
			break;

		case 3:	
			document.getElementById(id).src = './Themes/'+Theme+'/Folder_Disabled.jpg';
			break;
	}
}	


function ToggleUSSFImage(id,state)
{
	position="main.js";
	whatfunc="ToggleUSSFImage()";

	switch (state)
	{
		case 0:		
			document.getElementById(id).src = './Themes/'+Theme+'/USSF_Out.jpg';
			break;

		case 1:
			document.getElementById(id).src = './Themes/'+Theme+'/USSF_Over.jpg';
			break;

		case 2:	
			document.getElementById(id).src = './Themes/'+Theme+'/USSF_Down.jpg';
			break;

		case 3:	
			document.getElementById(id).src = './Themes/'+Theme+'/USSF_Disabled.jpg';
			break;
	}
}	


function ToggleDefaultImage(id,state)
{
	position="main.js";
	whatfunc="ToggleDefaultImage()";

	switch (state)
	{
		case 0:		
			document.getElementById(id).src = './Themes/'+Theme+'/DefaultImage_Out.jpg';
			break;

		case 1:
			document.getElementById(id).src = './Themes/'+Theme+'/DefaultImage_Over.jpg';
			break;

		case 2:	
			document.getElementById(id).src = './Themes/'+Theme+'/DefaultImage_Down.jpg';
			break;

		case 3:	
			document.getElementById(id).src = './Themes/'+Theme+'/DefaultImage_Disabled.jpg';
			break;
	}
}	


function RegKeyExists(KeyBase)
{
	position="core.js";
	whatfunc="RegKeyExists()";

	try
	{
		WshShell.RegRead(KeyBase);

		return true;
	} 
	catch (exc) 
	{
		return false;
	}
}


function RegKeyValue(KeyBase)
{
	position="core.js";
	whatfunc="RegKeyValue()";

	var value;

	try
	{
		value=WshShell.RegRead(KeyBase);

		return value;
	} 
	catch (exc) 
	{
		return null;
	}
}
